// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_LF_MOM_BACKEND/grmi"
	meta "LAPP_LF_MOM_BACKEND/meta/om"
	model "LAPP_LF_MOM_BACKEND/models/om"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : DemandHeadFromDBDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : DemandHeadFromDB的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-05-13 16:05:11
 *
 ******************************************************************************/
type DemandHeadFromDBDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewDemandHeadFromDBDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个DemandHeadFromDBDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : DemandHeadFromDBDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-05-13 16:05:11
 *
 ******************************************************************************/
func NewDemandHeadFromDBDAOImplement(session *xorm.Session, plantNr int, userid string) *DemandHeadFromDBDAOImplement {
	return &DemandHeadFromDBDAOImplement{session, &meta.DemandHeadFromDB, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/DemandHeadFromDBDAO.InsertOne
 *
 ******************************************************************************/
func (impl *DemandHeadFromDBDAOImplement) InsertOne(entity *model.DemandHeadFromDB) (*model.DemandHeadFromDB, error) {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return entity, grmi.NewDataBaseError(err)
	}
	return entity, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/DemandHeadFromDBDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *DemandHeadFromDBDAOImplement) DeleteOne(taskNr int) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, taskNr}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/DemandHeadFromDBDAO.SelectOne
 *
 ******************************************************************************/
func (impl *DemandHeadFromDBDAOImplement) SelectOne(taskNr int) (*model.DemandHeadFromDB, error) {
	var data model.DemandHeadFromDB
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, taskNr}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/DemandHeadFromDBDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *DemandHeadFromDBDAOImplement) UpdateOne(entity *model.DemandHeadFromDB) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/DemandHeadFromDBDAO.Insert
 *
 ******************************************************************************/
func (impl *DemandHeadFromDBDAOImplement) Insert(entities *[]model.DemandHeadFromDB) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/DemandHeadFromDBDAO.Delete
 *
 ******************************************************************************/
func (impl *DemandHeadFromDBDAOImplement) Delete(entities *[]model.DemandHeadFromDB) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/DemandHeadFromDBDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *DemandHeadFromDBDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.DemandHeadFromDB_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/DemandHeadFromDBDAO.Select
 *
 ******************************************************************************/
func (impl *DemandHeadFromDBDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.DemandHeadFromDB, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.DemandHeadFromDB_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.DemandHeadFromDB_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.DemandHeadFromDB, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/DemandHeadFromDBDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *DemandHeadFromDBDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.DemandHeadFromDB_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by " + meta.DemandHeadFromDB_PlantNr.ColumnName
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.DemandHeadFromDB, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(impl.meta.TableName).SQL("select * from "+impl.meta.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/DemandHeadFromDBDAO.Update
 *
 ******************************************************************************/
func (impl *DemandHeadFromDBDAOImplement) Update(entities *[]model.DemandHeadFromDB) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/DemandHeadFromDBDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *DemandHeadFromDBDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.DemandHeadFromDB, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.DemandHeadFromDB_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.DemandHeadFromDB_LastUser.ColumnName)
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}


/******************************************************************************
 *
 * @Reference LAPP_LF_MOM_BACKEND/dao/om/DemandHeadDAO.SelectUnparsedTask
 *
 ******************************************************************************/
func (impl *DemandHeadFromDBDAOImplement) SelectUnparsedTask() ([]model.DemandHeadFromDB, error) {

	where := fmt.Sprintf("%s = ? and %s = ? and %s < ?",
		meta.DemandHeadFromDB_PlantNr.ColumnName,
		meta.DemandHeadFromDB_Status.ColumnName,
		meta.DemandHeadFromDB_ErrNum.ColumnName)
	session := impl.session.Table(impl.meta.TableName).Where(where, impl.plantNr, model.DemandHeadUnParsedStatus, model.DemandMaxTry)
	session = session.OrderBy(meta.DemandHeadFromDB_PlantNr.ColumnName)
	session = session.OrderBy(meta.DemandHeadFromDB_TaskNr.ColumnName).Limit(1)

	data := make([]model.DemandHeadFromDB, 0, 1)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}